if (MSVC)
  set(ZLIB_PROJECT_NAME zlib_${ZLIB_VERSION})
  set(ZLIB_BUILD_ROOT ${EXTERNAL_BUILD_ROOT}/builds/${ZLIB_PROJECT_NAME})
  set(ZLIB_CMAKE_ARGS
    -DCMAKE_BUILD_TYPE=${EXTERNAL_BUILD_TYPE}
    -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
    -DCMAKE_GENERATOR=${CMAKE_GENERATOR}
    -DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}
    -DCMAKE_SHARED_LINKER_FLAGS=${CMAKE_SHARED_LINKER_FLAGS}
    -DCMAKE_POSITION_INDEPENDENT_CODE=ON
    -DCMAKE_INSTALL_PREFIX=${EXTERNAL_BUILD_ROOT}
  )
  ExternalProject_Add(zlib_project
    DOWNLOAD_NO_PROGRESS 1
    URL https://github.com/madler/zlib/archive/${ZLIB_VERSION}.tar.gz
    PREFIX ${ZLIB_BUILD_ROOT}
    CMAKE_ARGS ${ZLIB_CMAKE_ARGS}
  )
  set(ZLIB_LIBRARIES ${EXTERNAL_BUILD_ROOT}/lib/zlibstatic${DEBUG_EXTRA}.lib)
elseif(LINUX)
  set(ZLIB_LIBRARIES libz.a)
endif()
